<?php
add_filter('woocommerce_checkout_fields', 'payable_shipping_phone_checkout');

function payable_shipping_phone_checkout($fields)
{
   $fields['shipping']['shipping_phone'] = array(
      'label' => 'Phone',
      'required' => false,
      'class' => array('form-row-wide'),
      'priority' => 25,
   );

   // $fields['shipping']['shipping_mobile_phone'] = array(
   //    'label' => 'Mobile Phone',
   //    'required' => false,
   //    'class' => array('form-row-wide'),
   //    'priority' => 25,
   // );


   // $fields['billing']['billing_mobile_phone'] = array(
   //    'label' => 'Mobile Phone',
   //    'required' => false,
   //    'class' => array('form-row-wide'),
   //    'priority' => 25,
   // );

   return $fields;
}

add_action('woocommerce_admin_order_data_after_shipping_address', 'payable_shipping_phone_checkout_display');

function payable_shipping_phone_checkout_display($order)
{
   _e('<p><b>Shipping Phone:</b> ' . get_post_meta($order->get_id(), '_shipping_phone', true) . '</p>');
   // _e('<p><b>Shipping Mobile  Phone:</b> ' . get_post_meta($order->get_id(), '_shipping_mobile_phone', true) . '</p>');
   _e('<p><b>Shipping Email:</b> ' . get_post_meta($order->get_id(), '_shipping_email', true) . '</p>');
}

// add_action('woocommerce_admin_order_data_after_billing_address', 'payable_billing_phone_checkout_display');

// function payable_billing_phone_checkout_display($order)
// {

//    _e('<p><b>Billing Mobile  Phone:</b> ' . get_post_meta($order->get_id(), '_billing_mobile_phone', true) . '</p>');
// }



// add_filter('woocommerce_billing_fields', 'billing_phone_validation');
// function billing_phone_validation($fields)
// {
//    $fields['billing_phone']['required'] = true;
//    return $fields;
// }


//******custom validations**********************************////////////////////////

add_action('woocommerce_checkout_process', 'payable_validations');

function payable_validations()
{
   /**
    * 
    * Billing Details Validation 
    *    
    */
   //billing_first_name start
   $billing_first_name = filter_input(INPUT_POST, 'billing_first_name');
   if (strlen(trim(preg_replace('/^[a-zA-Z0-9\\. ]*$/', '', $billing_first_name))) > 0) {
      wc_add_notice(__('Invalid format for Billing Details - Contact First Name'), 'error');
   }
   if (strlen($billing_first_name) > 50) {
      wc_add_notice(__('Billing Details - Contact First Name length should be less
   than or equal to 50'), 'error');
   }



   //billing_last_name start
   $billing_last_name = filter_input(INPUT_POST, 'billing_last_name');
   if (strlen(trim(preg_replace('/^[a-zA-Z0-9\\. ]*$/', '', $billing_last_name))) > 0) {
      wc_add_notice(__('Invalid format for Billing Details - Contact Last Name'), 'error');
   }
   if (strlen($billing_last_name) > 50) {
      wc_add_notice(__('Billing Details - Contact Last Name length should be less
   than or equal to 50'), 'error');
   }



   //billing mobile phone start   	
   // $billing_mobile_phone = filter_input(INPUT_POST, 'billing_mobile_phone');
   // if ($billing_mobile_phone != "" || $billing_mobile_phone != NULL) {
   //    if (strlen(trim(preg_replace('/^[0-9\\+ ]*$/', '', $billing_mobile_phone))) > 0) {
   //       wc_add_notice(__('Please enter a valid Billing Details - Customer Mobile
   // Phone number [Format : 07XXXXXXXX OR +XXxxxxxxxxx]'), 'error');
   //    }

   //    if (strlen($billing_mobile_phone) > 15) {
   //       wc_add_notice(__('Billing Details -  Customer Mobile Phone number length should be less
   // than or equal to 15'), 'error');
   //    }

   //    if (strlen($billing_mobile_phone) < 10) {
   //       wc_add_notice(__('Billing Details - Mobile Phone cannot be less than 10 characters'), 'error');
   //    }
   // }



   //billing phone start	
   $billing_phone = filter_input(INPUT_POST, 'billing_phone');
   if (strlen(trim(preg_replace('/^[0-9\\+ ]*$/', '', $billing_phone))) > 0) {
      wc_add_notice(__('Please enter a valid Billing Details - Customer Mobile
   	Phone number [Format : 07XXXXXXXX OR +XXxxxxxxxxx]'), 'error');
   }

   if (strlen($billing_phone) > 15) {
      wc_add_notice(__('Customer Phone cannot be more than 15 characters'), 'error');
   }

   if ($billing_phone != "" && strlen($billing_phone) < 10) {
      wc_add_notice(__('Customer Phone cannot be less than 10 characters'), 'error');
   }


   //billing_address 1 start
   $billing_address_1 = filter_input(INPUT_POST, 'billing_address_1');
   if (strlen($billing_address_1) > 100) {
      wc_add_notice(__('Billing Address - Address Line 1 length should be less than or equal to 100 characters'), 'error');
   }
   if (strlen(trim(preg_replace('/^[a-zA-Z0-9&\.\-_\/,() ]*$/', '', $billing_address_1))) > 0) {
      wc_add_notice(__('Invalid format for Billing Address - Address Line 1'), 'error');
   }
   



   //billing_address 2 start
   $billing_address_2 = filter_input(INPUT_POST, 'billing_address_2');
   if (strlen($billing_address_2) > 100) {
      wc_add_notice(__('Billing Address - Address Line 2 length should be less than or equal to 100 characters'), 'error');
   }
   if (strlen(trim(preg_replace('/^[a-zA-Z0-9&\.\-_\/,() ]*$/', '', $billing_address_2))) > 0) {
      wc_add_notice(__('Invalid format for Billing Address - Address Line 2'), 'error');
   }
  



   //billing_city start
   $billing_city = filter_input(INPUT_POST, 'billing_city');
   if (strlen(trim(preg_replace('/^[a-zA-Z0-9\. ]*$/', '', $billing_city))) > 0) {
      wc_add_notice(__('Invalid format for Billing Address - City'), 'error');
   }

   if (strlen($billing_city) > 100) {
      wc_add_notice(__('Billing Address - City length should be less than or equal to 100 characters'), 'error');
   }
  



   //billing_postcode start
   $billing_postcode = filter_input(INPUT_POST, 'billing_postcode');
   if ($billing_postcode != "" || $billing_postcode != NULL) {
      if (strlen($billing_postcode) > 10) {
         wc_add_notice(__('Billing Address - Postal Code length should be less than or equal to 10 characters'), 'error');
      }
   }
   



   //billing_company start
   $billing_company = filter_input(INPUT_POST, 'billing_company');
   if (strlen($billing_company) > 100) {
      wc_add_notice(__('Billing Details - Company length should be less than or equal to 100 characters'), 'error');
   }
   if (strlen(trim(preg_replace('/^[a-zA-Z0-9&\.\-\/,() ]*$/', '', $billing_company))) > 0) {
      wc_add_notice(__('Invalid format for Billing Details - Company Name'), 'error');
   }
  



   //billing_state start
   $billing_state = filter_input(INPUT_POST, 'billing_state');
   if (strlen($billing_state) > 25) {
      wc_add_notice(__('Billing Details - State / Country length should be less than or equal to 25 characters'), 'error');
   }
   if (strlen(trim(preg_replace('/^[a-zA-Z0-9\._- ]*$/', '', $billing_state))) > 0) {
      wc_add_notice(__('Invalid format for Billing Details - State / Country'), 'error');
   }




   /**
    * 
    * Shipping Details Validation 
    *    
    */

   // shipping is working checkbox true
   $shipping_checkbox = filter_input(INPUT_POST, 'ship_to_different_address');
   if ($shipping_checkbox == 1) {

      //shipping_first_name start
      $shipping_first_name = filter_input(INPUT_POST, 'shipping_first_name');
      if (strlen(trim(preg_replace('/^[a-zA-Z0-9\\. ]*$/', '', $shipping_first_name))) > 0) {
         wc_add_notice(__('Invalid format for Shipping Details - Contact First Name'), 'error');
      }
      if (strlen($shipping_first_name) > 50) {
         wc_add_notice(__('Shipping Details - Contact First Name length should be less
   	than or equal to 50'), 'error');
      }



      //shipping_last_name start
      $shipping_last_name = filter_input(INPUT_POST, 'shipping_last_name');
      if (strlen(trim(preg_replace('/^[a-zA-Z0-9\\. ]*$/', '', $shipping_last_name))) > 0) {
         wc_add_notice(__('Invalid format for Shipping Details - Contact Last Name'), 'error');
      }
      if (strlen($shipping_last_name) > 50) {
         wc_add_notice(__('Shipping Details - Contact Last Name length should be less
   	than or equal to 50'), 'error');
      }



      //shipping phone start			
      $shipping_phone = filter_input(INPUT_POST, 'shipping_phone');
      if ($shipping_phone != "" || $shipping_phone != NULL) {

         if (strlen(trim(preg_replace('/^[0-9\\+ ]*$/', '', $shipping_phone))) > 0) {
            wc_add_notice(__('Please enter a valid Shipping Address - Customer Phone
   		 [Format : 07XXXXXXXX OR +XXxxxxxxxxx]'), 'error');
         }

         if (strlen($shipping_phone) > 15) {
            wc_add_notice(__('Shipping Address - Customer Phone cannot be more than 15 characters'), 'error');
         }

         if (strlen($shipping_phone) < 10) {
            wc_add_notice(__('Shipping Address -  Customer Phone cannot be less than 10 characters'), 'error');
         }
      }



      //shipping mobile_phone start
      // $shipping_mobile_phone = filter_input(INPUT_POST, 'shipping_mobile_phone');
      // if ($shipping_mobile_phone != "" || $shipping_mobile_phone != NULL) {

      //    if ($shipping_mobile_phone != '' && strlen(trim(preg_replace('/^[0-9\\+ ]*$/', '', $shipping_mobile_phone))) > 0) {
      //       wc_add_notice(__('Please enter a valid Shipping Details - Customer Mobile
   	// 	Phone number [Format : 07XXXXXXXX OR +XXxxxxxxxxx]'), 'error');
      //    }

      //    if (strlen($shipping_mobile_phone) > 15) {
      //       wc_add_notice(__('Shipping Details -  Customer Mobile Phone number length should be less
   	// 	than or equal to 15'), 'error');
      //    }
      //    if (strlen($shipping_mobile_phone) < 10) {
      //       wc_add_notice(__('Shipping Details - Customer Mobile Phone cannot be less than 10 characters'), 'error');
      //    }
      // }



      //shipping postcode start
      $shipping_postcode = filter_input(INPUT_POST, 'shipping_postcode');
      if ($shipping_postcode != "" || $shipping_postcode != NULL) {
         if (strlen($shipping_postcode) > 10) {
            wc_add_notice(__('Shipping Address - Postal Code length should be less than or equal to 10 characters'), 'error');
         }
      }



      //shipping_address 1 start
      $shipping_address_1 = filter_input(INPUT_POST, 'shipping_address_1');
      if (strlen($shipping_address_1) > 100) {
         wc_add_notice(__('Shipping Address - Address Line 1 length should be less than or equal to 100 characters'), 'error');
      }
      if (strlen(trim(preg_replace('/^[a-zA-Z0-9&\.\-_\/,() ]*$/', '', $shipping_address_1))) > 0) {
         wc_add_notice(__('Invalid format for Shipping Address - Address Line 1'), 'error');
      }



      //shipping_address 2 start
      $shipping_address_2 = filter_input(INPUT_POST, 'shipping_address_2');
      if (strlen($shipping_address_2) > 100) {
         wc_add_notice(__('Shipping Address - Address Line 2 length should be less than or equal to 100 characters'), 'error');
      }
      if (strlen(trim(preg_replace('/^[a-zA-Z0-9&\.\-_\/,() ]*$/', '', $shipping_address_2))) > 0) {
         wc_add_notice(__('Invalid format for Shipping Address - Address Line 2'), 'error');
      }



      //shipping_city start
      $shipping_city = filter_input(INPUT_POST, 'shipping_city');
      if (strlen(trim(preg_replace('/^[a-zA-Z0-9\. ]*$/', '', $shipping_city))) > 0) {
         wc_add_notice(__('Invalid format for Shipping Address - City'), 'error');
      }

      if (strlen($shipping_city) > 100) {
         wc_add_notice(__('Shipping Address - City length should be less than or equal to 100 characters'), 'error');
      }



      //shipping_company start
      $shipping_company = filter_input(INPUT_POST, 'shipping_company');
      if (strlen($shipping_company) > 100) {
         wc_add_notice(__('Shipping Details - Company length should be less than or equal to 100 characters'), 'error');
      }

      if (strlen(trim(preg_replace('/^[a-zA-Z0-9&\.\-\/,() ]*$/', '', $shipping_company))) > 0) {
         wc_add_notice(__('Invalid format for Shipping Details - Company Name'), 'error');
      }



      // shipping_state
      $shipping_state = filter_input(INPUT_POST, 'shipping_state');
      if (strlen(trim(preg_replace('/^[a-zA-Z0-9\._- ]*$/', '', $shipping_state))) > 0) {
         wc_add_notice(__('Invalid format for Shipping Details - State / Country'), 'error');
      }
   }

}
//**************** Validation End ******************


class Wc_WooCommercePayablepayment extends WC_Payment_Gateway
{

   private $allowedCurrencies = array(
      'LKR'
   );
   private $SUCCESS_CALLBACK_URL = "payable_payment_success";
   private $FAILURE_CALLBACK_URL = "payable_payment_failure";
   private $SUCCESS_REDIRECT_URL = "/checkout/order-received/";
   private $FAILURE_REDIRECT_URL = "/checkout/order-received/";
   private $API_HOST;
   private $RETRIVE_URL;
   private $API_SESSION_CREATE_ENDPOINT = "/checkout/v1/session/create";

   public function __construct()
   {
      $this->id = 'woo-payablev2'; // payment gateway plugin ID

      $plugin_dir = plugin_dir_url(__FILE__);
      $this->icon = $plugin_dir . 'logo.png';
      $this->icon = apply_filters('woocommerce_payable_gateway_icon', $this->icon);

      // URL of icon that will be displayed on the checkout page
      $this->has_fields = true;
      $this->method_title = 'Payable Payment Gateway Plugin';
      $this->method_description = 'Payable Payment Gateway Plugin.'; //displayed on option page
      $this->supports = array(
         'products'
      );

      // Method with all the options fields
      $this->init_form_fields();

      // Load the settings.
      $this->init_settings();
      $this->title = $this->get_option('title');
      $this->description = $this->get_option('description');

      // Checking if valid to use
      if ($this->is_valid_for_use()) {
         $this->enabled = $this->get_option('enabled');
      } else {
         $this->enabled = 'no';
      }

      // Payable end point	   
      if ($this->get_option('testmode') == 'yes') {
         $this->API_HOST = $this->get_option('sandbox_api_url');
         $this->RETRIVE_URL = $this->get_option('retrive_sandbox_url');
      } else {
         $this->API_HOST = $this->get_option('live_api_url');
         $this->RETRIVE_URL = $this->get_option('retrive_live_url');
      }

      // Site URL
      $this->siteUrl = get_site_url();

      // redirect URL
      $this->REDIRECT_URL = "";
      $redirectPage = $this->get_option('redirect_page');
      if ($redirectPage != '' || $redirectPage != 0) {
         $this->REDIRECT_URL = get_permalink($redirectPage);
      } else {
         $this->REDIRECT_URL = get_site_url();
      }

      $this->testmode = 'yes' === $this->get_option('testmode');
      $this->merchant_id = $this->testmode ? $this->get_option('test_merchant_id') : $this->get_option('merchant_id');
      $this->auth_token = $this->testmode ? $this->get_option('test_auth_token') : $this->get_option('auth_token');
      //$this->get_option('auth_token');
      $this->country_code = $this->get_option('country_code');

      $this->checkout_cbc_path = "cbcmpgs.gateway.mastercard.com";
      $this->checkout_cbc_version = "57";
      $this->checkout_js_path = "https://" . $this->checkout_cbc_path . "/checkout/version/" . $this->checkout_cbc_version . "/checkout.js";


      add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'process_admin_options'));

      add_action('woocommerce_api_' . $this->SUCCESS_CALLBACK_URL, array($this, 'payment_success'));
      add_action('woocommerce_api_' . $this->FAILURE_CALLBACK_URL, array($this, 'payment_failure'));

      add_action('woocommerce_api_payable_payment_successpage', array($this, 'payable_payment_successpage'));
      add_action('woocommerce_api_payment_failurepage', array($this, 'payment_failurepage'));
      add_action('woocommerce_api_payable', array($this, 'webhook'));

      add_action('woocommerce_api_wc_gateway_mysolugion', array($this, 'check_callback'));
      add_action('woocommerce_api_payable_notification', array($this, 'payable_notification'));
      add_action('woocommerce_gateway_icon', array(&$this, 'gateway_payable_description'), 10, 2);

      add_action('woocommerce_checkout_process', array(&$this, 'payable_custom_checkout_field_process'));
      add_action('wp_footer', array($this, 'enqueueAssets'));
      // add_filter('woocommerce_email_order_meta_fields', array( $this,'custom_woocommerce_email_order_meta_fields'), 10, 3);
   }




   public function enqueueAssets()
   {
      wp_register_script('waitanimation', plugins_url('../js/anime.min.js', __FILE__), array('jquery'), '', true);
      wp_enqueue_script('waitanimation');

      wp_register_script('waitanimationjs', plugins_url('../js/animation.js', __FILE__), array('jquery'), '', true);
      wp_enqueue_script('waitanimationjs');

      wp_register_script('checkoutwaiting', $this->checkout_js_path, array('jquery'), '', true);
      // wp_register_script('checkoutwaiting', plugins_url('../js/checkout.js', __FILE__), array('jquery'), '', true);
      wp_enqueue_script('checkoutwaiting');

      //   wp_enqueue_style('bootstrap4', plugins_url('../css/bootstrap.min.css', __FILE__));
      //   wp_enqueue_style('bootstrap4');

      wp_enqueue_style('fontawsome', plugins_url('../css/font-awesome.min.css', __FILE__));
      wp_enqueue_style('fontawsome');
   }




   public function init_form_fields()
   {
      $this->form_fields = array(
         'enabled' => array(
            'title'       => 'Enable/Disable',
            'label'       => 'Enable Payable Gateway',
            'type'        => 'checkbox',
            'description' => '',
            'default'     => 'no'
         ),
         'title' => array(
            'title'       => 'Title',
            'type'        => 'text',
            'description' => 'This controls the title which the user sees during checkout.',
            'default'     => 'Visa / Mastercard',
            'desc_tip'    => true,
         ),
         'description' => array(
            'title'       => 'Description',
            'type'        => 'text',
            'description' => 'This controls the description which the user sees during checkout.',
            'default'     => 'Pay using Visa or Mastercard with PAYable',
            'desc_tip'    => true,
         ),
         'business_name' => array(
            'title' => 'Business Name',
            'type' => 'text',
            'description' => 'Business Name',
            'default'     => 'Payable Payment',
            'desc_tip'    => true,
         ),
         'live_api_url' => array(
            'title'       => 'Live API url',
            'type'        => 'text',
            'description' => 'Payable API url',
            'desc_tip'    => true,
         ),
         'sandbox_api_url' => array(
            'title'       => 'Sandbox API url',
            'type'        => 'text',
            'description' => 'Payable sandbox API url',
            'desc_tip'    => true,
         ),
         'retrive_sandbox_url' => array(
            'title'       => 'Retrive sandbox url',
            'type'        => 'text',
            'description' => 'Retrive sandbox url Payable',
            'desc_tip'    => true,
         ),
         'retrive_live_url' => array(
            'title'       => 'Retrive live url',
            'type'        => 'text',
            'description' => 'Retrive live url Payable',
            'desc_tip'    => true,
         ),
         'testmode' => array(
            'title'       => 'Test mode',
            'label'       => 'Enable Test Mode',
            'type'        => 'checkbox',
            'description' => 'Place the payment gateway in test mode using test API keys.',
            'default'     => 'yes',
            'desc_tip'    => true,
         ),
         'test_merchant_id' => array(
            'title'       => 'Test MerchantID',
            'type'        => 'text',
            'placeholder' => 'Enter Test MerchantID'
         ),
         'test_auth_token' => array(
            'title'       => 'Test Auth Token',
            'type'        => 'text',
            'placeholder' => 'Enter Test Auth Token'
         ),
         'merchant_id' => array(
            'title'       => 'Live MerchantID',
            'type'        => 'text',
            'placeholder' => 'Enter Live MerchantID'
         ),
         'auth_token' => array(
            'title'       => 'Live Auth Token',
            'type'        => 'text',
            'placeholder' => 'Enter Live Auth Token'
         ),
         'country_code' => array(
            'type' => 'select',
            'title' => 'Country',
            'label' => 'Country',
            'options' => array(
               ''   => 'Select Country',
               'LKR' => 'Sri lanka'
            ),
         ),
         'redirect_page' => array(
            'title' => ('Return Page'),
            'type' => 'select',
            'options' => $this->get_wordpress_page_list('Select Page'),
            'desc_tip' => true
         )
      );
   }



   /**
    * Get all page list from WordPress
    **/
   function get_wordpress_page_list($title = false, $indent = true)
   {
      error_log("DirectPay_WC get_wordpress_page_list");
      $wp_pages = get_pages('sort_column=menu_order');
      $page_list = array();
      if ($title) $page_list[] = $title;
      foreach ($wp_pages as $page) {
         $prefix = '';
         // show indented child pages?
         if ($indent) {
            $has_parent = $page->post_parent;
            while ($has_parent) {
               $prefix .= ' - ';
               $next_page = get_post($has_parent);
               $has_parent = $next_page->post_parent;
            }
         }
         // add to page list array array
         $page_list[$page->ID] = $prefix . $page->post_title;
      }
      return $page_list;
   }






   public function gateway_payable_description($icon, $payment_id)
   {
      if (strpos($payment_id, 'woo-payablev2') !== false) {
         // $description_text = __("You can pay with your credit card if you don’t have a payable account...", "woocommerce");

         // this line disabled due to 2 div displaying under payment type
         // $icon .= '</label><div class="payment_box payment_method_'.$payment_id.'" ></div>';
      }
      return $icon;
   }





   function is_valid_for_use()
   {
      return in_array(get_woocommerce_currency(), $this->allowedCurrencies);
   }




   function admin_options()
   {
      if (strlen(trim(preg_replace('/^[a-zA-Z0-9]*$/', '', $this->merchant_id))) > 0) {
?>
         <div class="notice error is-dismissible">
            <p><?php _e('Invalid format for Merchant Key ', 'woo-payablev2'); ?></p>
         </div>
      <?php
      } else if (!$this->is_valid_for_use()) {
      ?>
         <div class="notice error is-dismissible">
            <p><?php _e('Payable Does not support the selected currency ' . get_woocommerce_currency() . '!', 'woo-payablev2'); ?></p>
         </div>
      <?php
      } else {
         parent::admin_options();
      }
   }






   public function validate_country_code_field($key, $value)
   {
      if ($this->validate_currency_with_country($value)) {
         return $value;
      } else {
      ?>
         <div class="notice error is-dismissible">
            <p><?php _e('Payable does not support ' . get_woocommerce_currency() . ' for the selected country! ' . $this->validate_currency_with_country($value), 'woo-payablev2'); ?></p>
         </div>
      <?php
      }
   }




   public function payable_custom_checkout_field_process()
   {
      global $woocommerce;
      // Check if set, if its not set add an error. This one is only requite for companies      
      if (!(preg_match('/^[0-9]{10}$/D', $_POST['billing_phone']))) {
         wc_add_notice("Incorrect Phone Number! Please enter valid 10 digits phone number", 'error');
      }
   }






   private function validate_currency_with_country($value)
   {
      $status = true;
      /*
      $status = false;
      switch ($value) {
         case "LK":
            $status = get_woocommerce_currency() == 'LKR';
            break;
      }
      */
      return $status;
   }




   public function checkValue($invoiceId, $amount, $currencyCode = 'LKR')
   {
      //UPPERCASE(SHA512[<MerchantKey>|<invoiceId>|<amount>|<currencyCode>|UPPERCASE(SHA512[<MerchantToken>])])
      $MerchantKey = $this->merchant_id;
      $token = $this->auth_token;
      $hashedtoken = strtoupper(hash("sha512", $token));
      $combined = $MerchantKey . '|' . $invoiceId . '|' . $amount . '|' . $currencyCode . '|' . $hashedtoken;
      return strtoupper(hash("sha512", $combined));
   }






   function wpbo_get_woo_version_number()
   {
      // If get_plugins() isn't available, require it
      if (!function_exists('get_plugins'))
         require_once(ABSPATH . 'wp-admin/includes/plugin.php');

      // Create the plugins folder and file variables
      $plugin_folder = get_plugins('/' . 'woocommerce');
      $plugin_file = 'woocommerce.php';

      // If the plugin version number is set, return it 
      if (isset($plugin_folder[$plugin_file]['Version'])) {
         return 'W' . $plugin_folder[$plugin_file]['Version'];
      } else {
         // Otherwise return null
         return NULL;
      }
   }


   public function process_payment($order_id)
   {
      global $woocommerce;

      //To receive order id
      $order = wc_get_order($order_id);

      //To receive order amount
      $amount = $order->get_total();

      //To receive woocommerce Currency
      $currency = get_woocommerce_currency();

      //To receive user id and order details
      $merchantCustomerId = $order->get_user_id();
      $merchantOrderId = $order->get_order_number();
      $orderIdString = '?orderId=' . $order_id;
      $transaction = array(
         "amount" => $amount,
         "currency" => $currency,
      );
      $transactions = array(
         $transaction
      );

      $MerchantKey = $this->merchant_id;
      $token = $this->auth_token;


      //Get customer details
      $first_name = $order->get_billing_first_name();
      $last_name = $order->get_billing_last_name();
      $email = $order->get_billing_email();
      $contact_number = $order->get_billing_phone();
      $address_line_one = $order->get_billing_address_1();
      $address_line_two = $order->get_billing_address_2();
      $city = $order->get_billing_city();
      $state = $order->get_billing_state();
      $postal_code = $order->get_billing_postcode();
      $country = $order->get_billing_country();
      $shipping_first_name = $order->get_shipping_first_name();
      $shipping_last_name = $order->get_shipping_last_name();
      $shipping_company = $order->get_shipping_company();
      $shipping_address_1 = $order->get_shipping_address_1();
      $shipping_address_2 = $order->get_shipping_address_2();
      $shipping_city = $order->get_shipping_city();
      $shipping_state = $order->get_shipping_state();
      $shipping_postcode = $order->get_shipping_postcode();
      $shipping_country = $order->get_shipping_country();
      $total = $order->get_total();
      $total =  number_format((float)$total, 2, '.', '');
      $invoice_no = $order->get_id();
      $checkValue = $this->checkValue($invoice_no, $total, 'LKR');
      $shipping_phone = get_post_meta($order->get_id(), '_shipping_phone', true);

      $billing_company    = $order->get_billing_company();
      $shipping_mobile_phone = get_post_meta($order->get_id(), '_shipping_mobile_phone', true);
      $billing_mobile_phone = get_post_meta($order->get_id(), '_billing_mobile_phone', true);
      $shipping_email = get_post_meta($order->get_id(), '_shipping_email', true);



      $requestBody = array(
         'merchantKey' => $MerchantKey,
         "notificationUrl" => $this->siteUrl . "/payable/wc-api/payable",
         "merchantNotificationUrl" => $this->siteUrl . "/payable/wc-api/payable_notification",
         "sdkVersion" => $this->wpbo_get_woo_version_number(),
         "invoiceId" => $invoice_no,
         "orderDescription" => "Order  from " . $this->get_option('business_name'),
         "customerFirstName" => (!empty($first_name) ? $first_name : ''),
         "customerLastName" => (!empty($last_name) ? $last_name : ''),
         "customerEmail" => (!empty($email) ? $email : ''),
         "customerMobilePhone" => (!empty($contact_number) ? $contact_number : ''),
         "customerPhone" => (!empty($billing_mobile_phone) ? $billing_mobile_phone : ''),
         "billingAddressStreet" => (!empty($address_line_one) ? $address_line_one : ''),
         "billingAddressStreet2" => (!empty($address_line_two) ? $address_line_two : ''),
         "billingAddressCity" => (!empty($city) ? $city : ''),
         "billingAddressCompany" => $billing_company,
         "billingAddressCountry" => $country,
         "billingAddressPostcodeZip" => (!empty($postal_code) ? $postal_code : '0000'),
         "billingAddressStateProvince" => (!empty($state) ? $state : ''),
         "shippingAddressStreet" => (!empty($shipping_address_1) ? $shipping_address_1 : ''),
         "shippingAddressStreet2" => (!empty($shipping_address_2) ? $shipping_address_2 : ''),
         "shippingAddressCity" => (!empty($shipping_city) ? $shipping_city : ''),
         "shippingAddressCompany" => (!empty($shipping_company) ? $shipping_company : ''),
         "shippingAddressCountry" => $shipping_country,
         "shippingAddressPostcodeZip" => (!empty($shipping_postcode) ? $shipping_postcode : '0000'),
         "shippingAddressStateProvince" => (!empty($shipping_state) ? $shipping_state : ''),
         "shippingContactEmail" => (!empty($shipping_email) ? $shipping_email : null),
         "shippingContactFirstName" => (!empty($shipping_first_name) ? $shipping_first_name : ''),
         "shippingContactLastName" => (!empty($shipping_last_name) ? $shipping_last_name : ''),
         "shippingContactMobilePhone" => (!empty($shipping_phone) ? $shipping_phone : ''),
         "shippingContactPhone" => (!empty($shipping_mobile_phone) ? $shipping_mobile_phone : ''),
         "merchantReturnUrl" => $this->siteUrl . "/payable/wc-api/payable_payment_successpage",
         "merchantCancelUrl" => $this->siteUrl . "/payable/wc-api/payable_payment_failurepage",
         "custom1" => " ",
         "custom2" => " ",
         "currencyCode" => "LKR",
         "amount" => $total,
         "checkValue" => $checkValue
      );

      $header = array(
         'Content-Type' => 'application/json'
      );

      $args = array(
         'method' => 'POST',
         'headers' => $header,
         'timeout'     => 45,
         'body' => json_encode($requestBody),
      );

      //$apiUrl = $this->API_HOST . $this->API_SESSION_CREATE_ENDPOINT;
      $apiUrl = $this->API_HOST;
      //$apiUrl ='https://wjftz9gev9.execute-api.ap-southeast-1.amazonaws.com/sandbox/sdk/inittx';

      $response = wp_remote_post($apiUrl, $args);
      //echo var_dump($response);



      if (!is_wp_error($response)) {
         $body = json_decode($response['body'], true);
         $url = $this->siteUrl . '/wc-api/payable';

         if ($body['sessionId'] != '') {
            $sessionId = $body['sessionId'];
            $checkvalueincomming = $body['checkValue'];
            // $url = $body['payload']['url'];

            $order_payable = $body['orderId'];
            $order->update_meta_data('payable_session_id', $sessionId);

            WC()->session->__unset('payable_sessionId');
            WC()->session->__unset('order_id');
            WC()->session->__unset('payable_checkvalue');
            WC()->session->set('payable_checkvalue', $checkValue);
            WC()->session->set('payable_incomingcheckvalue', $checkvalueincomming);
            WC()->session->set('payable_order_id', $order_payable);
            WC()->session->set('payable_sessionId', $sessionId);
            WC()->session->set('order_id', $order_id);

            $MerchantKey = $this->merchant_id;
            $token = $this->auth_token;
            $hashedtoken = strtoupper(hash("sha512", $token));
            $checknew = $MerchantKey . '|' . $order_payable .  '|' . $hashedtoken;
            $respondcheckvalue = strtoupper(hash("sha512", $checknew));

            WC()->session->set('payable_rcheckvalue', $respondcheckvalue);

            // $session_note = "Payable Order: " . $order_payable; // disable for status issue update
            // $order->add_order_note($session_note);// disable for status issue update
            update_post_meta($order_id, '_session_id', $sessionId);
            // $order->update_status('processing');// disable for status issue update
            return array(
               'result' => 'success',
               'redirect' => $url
            );
         } else {
            wc_add_notice('Something went wrong. Please contact for inquiries.', 'error');
            return;
         }
      } else {
         wc_add_notice('Connection error.', 'error');
         return;
      }
   }



   public function payment_success()
   {
      $postData = file_get_contents('php://input');
      $response  = json_decode($postData);
   }


   public function payable_notification()
   {
      global $woocommerce;
      $postData = file_get_contents('php://input');
      $response  = json_decode($postData);

      $payableAmount = $response->payableAmount;
      $statusMessage = $response->statusMessage;
      $payableTransactionId = $response->payableTransactionId;
      $invoiceNo = $response->invoiceNo;
      $statusCode = $response->statusCode;
      $paymentType = $response->paymentType;
      $paymentMethod = $response->paymentMethod;
      $paymentScheme = $response->paymentScheme;
      $cardHolderName = $response->cardHolderName;
      $cardNumber = $response->cardNumber;

      if ($statusMessage == 'SUCCESS') {
         WC()->session->set('statusMessage', $statusMessage);
         WC()->session->set('payableTransactionId', $payableTransactionId);
         WC()->session->set('invoiceNo', $invoiceNo);
         WC()->session->set('statusCode', $statusCode);
         WC()->session->set('paymentType', $paymentType);
         WC()->session->set('paymentMethod', $paymentMethod);
         WC()->session->set('paymentScheme', $paymentScheme);
         WC()->session->set('cardHolderName', $cardHolderName);
         WC()->session->set('cardNumber', $cardNumber);

         update_post_meta($invoiceNo, 'statusMessage', $statusMessage);
         update_post_meta($invoiceNo, 'payableTransactionId', $payableTransactionId);
         update_post_meta($invoiceNo, 'cardHolderName', $cardHolderName);
         update_post_meta($invoiceNo, 'paymentScheme', $paymentScheme);
         update_post_meta($invoiceNo, 'statusMessage', $statusMessage);
         update_post_meta($invoiceNo, 'cardNumber', $cardNumber);

         $order = wc_get_order($invoiceNo);
         $amount = $order->get_total();

         $order->reduce_order_stock();

         $order->payment_complete();// $order->update_status('completed');         
         $payId= $invoiceNo ?? "";
         $order->add_order_note('PAYable payment successful.<br/>PAYable Payment ID: ' . $payId);
         $woocommerce->cart->empty_cart();

         WC()->session->__unset('payable_sessionId');
         WC()->session->__unset('order_id');
         WC()->session->__unset('payable_incomingcheckvalue');
         WC()->session->__unset('payable_order_id');
      } elseif ($statusMessage == 'FAILURE') {
         $order = wc_get_order($invoiceNo);
         $amount = $order->get_total();

         //if (isset($order->status) && $order->status != "completed") {
         if (isset($order->status) && $order->status != "processing") {
            update_post_meta($invoiceNo, 'statusMessage', $statusMessage);
            update_post_meta($invoiceNo, 'payableTransactionId', $payableTransactionId);
            update_post_meta($invoiceNo, 'cardHolderName', $cardHolderName);
            update_post_meta($invoiceNo, 'paymentScheme', $paymentScheme);
            update_post_meta($invoiceNo, 'statusMessage', $statusMessage);
            update_post_meta($invoiceNo, 'cardNumber', $cardNumber);
            $note = "Payable payment failed.";
            // if(isset($invoiceNo) && $invoiceNo!=""){
            //    $note .= " Payable Payment ID: ". $invoiceNo;
            // }
            $order->add_order_note($note);
            $order->update_status('failed');
         }
      } else {
         $order = wc_get_order($invoiceNo);
         $amount = $order->get_total();

         // if (isset($order->status) && $order->status != "completed") {
            if (isset($order->status) && $order->status != "processing") {
            update_post_meta($invoiceNo, 'statusMessage', $statusMessage);
            update_post_meta($invoiceNo, 'payableTransactionId', $payableTransactionId);
            update_post_meta($invoiceNo, 'cardHolderName', $cardHolderName);
            update_post_meta($invoiceNo, 'paymentScheme', $paymentScheme);
            update_post_meta($invoiceNo, 'statusMessage', $statusMessage);
            update_post_meta($invoiceNo, 'cardNumber', $cardNumber);
            $note = "Payable payment failed.";
            $order->add_order_note($note);
            $order->update_status('failed');
         }
      }
      $return_array = array(
         'statusCode' => $statusCode,
         'statusMessage' => $statusMessage,
         'invoiceNo' => $invoiceNo,
         'woocommerceStatus' => 'Payment status updated',
         'payableTransactionId' => $payableTransactionId
      );
      header('Content-Type: application/json');
      _e(json_encode($return_array));
      die();
   }






   public function payment_failure()
   {
      global $woocommerce;
      if (WC()->session->get('order_id')) {
         $order_id = WC()->session->get('order_id');
         $order = wc_get_order($order_id);

         if (isset($order->status) && $order->status != "processing" && $order->status != "failed") {
            $session_note = "Payable Order: Cancelled by customer";
            $order->add_order_note($session_note);

            $shop_url = wc_get_page_permalink('shop');

            if (!$order->update_status('cancelled')) {

               WC()->session->__unset('order_id');
               wp_safe_redirect($shop_url);
               exit;
            }
         } else {
            $shop_url = wc_get_page_permalink('shop');
         }
         $woocommerce->cart->empty_cart();
      }
      wp_safe_redirect($shop_url);
      die();
   }







   public function webhook()
   {
      if (WC()->cart->get_cart_contents_count() == 0) {
         wc_add_notice('Something went wrong,.Please contact for inquiries.', 'error');
         wp_redirect(site_url());
         exit;
      }

      if (!isset($_GET['resultIndicator'])) {
         $sees = WC()->session->get('payable_sessionId');

      ?>
         <html>

         <head>
            <script src="https://cbcmpgs.gateway.mastercard.com/checkout/version/57/checkout.js" data-error="errorCallback" data-cancel="cancelCallback"></script>
            <script type="text/javascript">
               function Redirect() {
                  window.location = "<?php _e($this->siteUrl) ?>/wc-api/payable_payment_failure";
               }

               function errorCallback(error) {
                  console.log(JSON.stringify(error));
                  document.write("You will be redirected to main page in 10 sec.");
                  setTimeout('Redirect()', 10000);

               }

               function cancelCallback() {
                  document.write("You will be redirected to main page in 10 sec.");
                  setTimeout('Redirect()', 10000);
               }
               Checkout.configure({
                  session: {
                     id: "<?php _e($sees) ?>"
                  },
                  interaction: {
                     displayControl: { // you may change these settings as you prefer
                        billingAddress: 'HIDE',
                        customerEmail: 'HIDE',
                        orderSummary: 'SHOW',
                        shipping: 'HIDE'
                     }
                  }
               });
            </script>
         </head>
         <!-- <body>
            Click one of below buttons to start payment process…
            <input type="button" value="Pay with Lightbox" onclick="Checkout.showLightbox();" />
            <input type="button" value="Pay with Payment Page" onclick="Checkout.showPaymentPage();"/>
            (You can display one or both of these methods to customer)
            </body> -->
         <script type="text/javascript">
            <?php
            if (WC()->cart->get_cart_contents_count() != 0) { ?>
               Checkout.showLightbox();
            <?php } ?>
         </script>
      <?php
      }


      if (isset($_GET['resultIndicator'])) {
      ?>
         <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
         <html xmlns="http://www.w3.org/1999/xhtml">

         <head>
            <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
            <title>Please Wait</title>
            <style type="text/css">
               .centered {
                  position: absolute;
                  top: 50%;
                  left: 50%;
                  transform: translate(-50%, -50%);
               }

               .loader {
                  border: 12px solid #a7a9ac;
                  border-radius: 50%;
                  border-top: 12px solid #4587c7;
                  border-bottom: 12px solid #4587c7;
                  width: 50px;
                  height: 50px;
                  -webkit-animation: spin 2s linear infinite;
                  animation: spin 2s linear infinite;
                  margin: auto;
               }

               .msg {
                  color: #4587c7;
                  font-size: 20px;
               }

               @-webkit-keyframes spin {
                  0% {
                     -webkit-transform: rotate(0deg);
                  }

                  100% {
                     -webkit-transform: rotate(360deg);
                  }
               }

               @keyframes spin {
                  0% {
                     transform: rotate(0deg);
                  }

                  100% {
                     transform: rotate(360deg);
                  }
               }
            </style>
         </head>

         <body class="set-bg">
            <div class="centered">
               <div class="loader"></div>
               <p class="msg">Please Wait</p>
            </div>

            <script type="text/javascript" src="<?php echo plugins_url('payable-payment-gateway-for-woocommerce/js/anime.min.js'); ?>"></script>
            <script type="text/javascript">
               var textWrapper = document.querySelector('.msg');
               textWrapper.innerHTML = textWrapper.textContent.replace(/\S/g, "<span class='letter'>$&</span>");

               anime.timeline({
                     loop: true
                  })
                  .add({
                     targets: '.msg .letter',
                     translateY: [100, 0],
                     translateZ: 0,
                     opacity: [0, 1],
                     easing: "easeOutExpo",
                     duration: 1400,
                     delay: (el, i) => 300 + 30 * i
                  }).add({
                     targets: '.msg .letter',
                     translateY: [0, -100],
                     opacity: [1, 0],
                     easing: "easeInExpo",
                     duration: 1200,
                     delay: (el, i) => 100 + 30 * i
                  });
               setTimeout(function() {
                  window.location.reload(1);
               }, 15000);
            </script>
         </body>

         </html>


         <?php
         global $woocommerce;
         $url = $this->siteUrl;
         $MerchantKey = $this->merchant_id;
         $token = $this->auth_token;
         $checkvalueincomming = WC()->session->get('payable_incomingcheckvalue');
         $checkvalueWP = WC()->session->get('payable_checkvalue');
         $checkvalueWPnew = WC()->session->get('payable_rcheckvalue');

         $order_payable = WC()->session->get('payable_order_id');
         $order_id = WC()->session->get('order_id');


         //To receive order amount

         $requestBody = array(
            "orderId" => $order_payable,
            "merchantKey" => $MerchantKey,
            "checkValue" => $checkvalueWPnew
         );

         $header = array(
            'Content-Type' => 'application/json'
         );

         $args = array(
            'method' => 'POST',
            'headers' => $header,
            'timeout'     => 45,
            'body' => json_encode($requestBody),
         );

         //$apiUrl = $this->api_host . $this->API_SESSION_CREATE_ENDPOINT;
         $retrievetxUrl = $this->RETRIVE_URL;
         $response = wp_remote_post($retrievetxUrl, $args);
         //var_dump($response);      

         if (!is_wp_error($response)) {
            //$this->payable_payment_successpage();
            wp_redirect(home_url() . '/payable/wc-api/payable_payment_successpage');
            //payable_payment_successpage
            exit();
         }
         exit;
      }
      die();
   }









   function payable_payment_successpage()
   {
      $order_id = WC()->session->get('order_id');

      $statusMessage = get_post_meta($order_id, 'statusMessage');
      $payableTransactionId = get_post_meta($order_id, 'payableTransactionId');
      $cardHolderName = get_post_meta($order_id, 'cardHolderName');
      $paymentScheme = get_post_meta($order_id, 'paymentScheme');
      $cardNumber = get_post_meta($order_id, 'cardNumber');
      global $woocommerce;

      //To receive order id
      $order = wc_get_order($order_id);

      //To receive order amount
      $amount = $order->get_total();


      if ($statusMessage[0] == 'SUCCESS') {
         $woocommerce->cart->empty_cart();
         ?>
         <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
         <html xmlns="http://www.w3.org/1999/xhtml">

         <head>
            <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
            <title>Payment Confirmation</title>
            <style type="text/css">
               body {
                  background: #f2f2f2;
               }

               .payment {
                  border: 1px solid #f2f2f2;
                  height: auto;
                  border-radius: 20px;
                  background: #fff;
               }

               .payment_header {
                  background: #47c9a2;
                  padding: 20px;
                  border-radius: 20px 20px 0px 0px;
               }

               .payment_header_title {
                  color: #70caa2;
               }

               .check {
                  margin: 0px auto;
                  width: 50px;
                  height: 50px;
                  border-radius: 100%;
                  background: #fff;
                  text-align: center;
               }

               .check i {
                  vertical-align: middle;
                  line-height: 50px;
                  font-size: 30px;
                  color: #70caa2;
                  position: absolute;
                  margin-left: -9px;
                  margin-top: 14px;
                  width: 14px;
                  height: 8px;
                  border-bottom: solid 5px currentColor;
                  border-left: solid 5px currentColor;
                  -webkit-transform: rotate(-45deg);
                  transform: rotate(-45deg);
               }

               .content {
                  text-align: center;
                  padding: 30px 30px 30px;
               }

               .content h1 {
                  font-size: 25px;
               }

               .btn-inline>.btn {
                  color: #fff;
                  border-radius: 5px;
                  padding: 8px 30px;
                  transition: all ease-in-out 0.3s;
               }

               .btn-inline .print-btn {
                  background: transparent;
                  border: 1px solid #000;
                  color: #000;
                  transition: all ease-in-out 0.3s;
               }

               .btn-inline .print-btn:hover {
                  background: #000;
                  border: 1px solid #000;
                  color: #fff;
               }

               .btn-inline .back-to-home-btn {
                  color: #fff;
                  border-radius: 5px;
                  padding: 8px 30px;
                  background: #000;
                  transition: all ease-in-out 0.3s;
               }

               .content a:hover {
                  text-decoration: none;
                  background: #000;
               }

               .details {
                  margin: 0 0 30px;
                  padding: 30px 15px;
                  text-align: left;
                  color: #444;
               }

               @media print {

                  .btn-inline,
                  .payment_header {
                     display: none;
                  }
               }
            </style>
         </head>

         <body>
            <div class="container">
               <div class="row">
                  <div class="col-md-7 mx-auto mt-5">
                     <div class="payment">
                        <div class="payment_header">
                           <div class="check"><i class="fa" aria-hidden="true"></i></div>
                        </div>
                        <div class="content">
                           <h1 class="payment_header_title">Payment Success !</h1>
                           <p>Your order has been successfully processed!</p>
                           <div class="details">
                              <h4>Payment Information</h4>
                              <table class="table basic-table removeBorder">
                                 <tbody>
                                    <tr>
                                       <td width="50%">Order Number</td>
                                       <td width="50%"><?php _e($order_id); ?></td>
                                    </tr>
                                    <tr>
                                       <td width="50%">Payable Transaction ID</td>
                                       <td width="50%"><?php _e($payableTransactionId[0]); ?></td>
                                    </tr>
                                    <tr>
                                       <td width="50%">Cardholder Name</td>
                                       <td width="50%">
                                          <?php _e($cardHolderName[0]); ?>
                                       </td>
                                    </tr>
                                    <tr>
                                       <td width="50%">Total Payment Amount</td>
                                       <td width="50%">LKR <?php _e($amount); ?> </td>
                                    </tr>
                                    <tr>
                                       <td width="50%">Payment Method</td>
                                       <td width="50%">
                                          <?php _e($paymentScheme[0]); ?>
                                       </td>
                                    </tr>

                                 </tbody>
                              </table>
                              <?php
                              ?>
                           </div>
                           <div class="btn-inline">
                              <a class="btn back-to-home-btn" href="<?php _e(esc_url($this->REDIRECT_URL));  ?>">Go to Home</a>
                              <a class="btn print-btn" href="" onclick="window.print();">Print</a>
                           </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
            <script>
               //window.onbeforeunload = function() { return "Your work will be lost."; };
            </script>

         </body>

         </html>
      <?php
      } else {  ?>
         <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
         <html xmlns="http://www.w3.org/1999/xhtml">

         <head>
            <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
            <title>Payment Confirmation</title>
            <style type="text/css">
               body {
                  background: #f2f2f2;
               }

               .payment {
                  border: 1px solid #f2f2f2;
                  height: auto;
                  border-radius: 20px;
                  background: #fff;
               }

               .payment_header {
                  background: #47c9a2;
                  padding: 20px;
                  border-radius: 20px 20px 0px 0px;
               }

               .payment_header_title {
                  color: #70caa2;
               }

               .check {
                  margin: 0px auto;
                  width: 50px;
                  height: 50px;
                  border-radius: 100%;
                  background: #fff;
                  text-align: center;
               }

               .check i {
                  vertical-align: middle;
                  line-height: 50px;
                  font-size: 30px;
                  color: #70caa2;
                  position: absolute;
                  margin-left: -9px;
                  margin-top: 14px;
                  width: 14px;
                  height: 8px;
                  border-bottom: solid 5px currentColor;
                  border-left: solid 5px currentColor;
                  -webkit-transform: rotate(-45deg);
                  transform: rotate(-45deg);
               }

               .content {
                  text-align: center;
                  padding: 30px 30px 30px;
               }

               .content h1 {
                  font-size: 25px;
               }

               .btn-inline>.btn {
                  color: #fff;
                  border-radius: 5px;
                  padding: 8px 30px;
                  transition: all ease-in-out 0.3s;
               }

               .btn-inline .print-btn {
                  background: transparent;
                  border: 1px solid #000;
                  color: #000;
                  transition: all ease-in-out 0.3s;
               }

               .btn-inline .print-btn:hover {
                  background: #000;
                  border: 1px solid #000;
                  color: #fff;
               }

               .btn-inline .back-to-home-btn {
                  color: #fff;
                  border-radius: 5px;
                  padding: 8px 30px;
                  background: #000;
                  transition: all ease-in-out 0.3s;
               }

               .content a:hover {
                  text-decoration: none;
                  background: #000;
               }

               .details {
                  margin: 0 0 30px;
                  padding: 30px 15px;
                  text-align: left;
                  color: #444;
               }

               @media print {

                  .btn-inline,
                  .payment_header {
                     display: none;
                  }
               }
            </style>
         </head>

         <body>

            <div class="container">
               <div class="row">
                  <div class="col-md-7 mx-auto mt-5">
                     <div class="payment">
                        <div class="payment_header">
                           <div class="check"><i class="fa" aria-hidden="true"></i></div>
                        </div>
                        <div class="content">
                           <h1 class="payment_header_title">Payment Success !</h1>
                           <p>Your order has been successfully processed.</p>
                           <p> Please refer the Email Receipt or contact <?php _e($this->get_option('business_name')); ?> for more information.</p>
                           <br />
                           <div class="btn-inline">
                              <a class="btn back-to-home-btn" href="<?php _e(esc_url($this->REDIRECT_URL));  ?>">Go to Home</a>
                           </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>

         </body>

         </html>
<?php
      }
      die();
   }
}
