<?php

namespace Payable\WooCommercePayable;

/**
 * Plugin Name: PAYable Payment Gateway for WooCommerce
 * Plugin URI:  https://payable.lk/payable.php
 * Description: PAYable Payment Gateway for WooCommerce from Payable Private Limited, Sri Lanka.
 * Version: 1.1.4
 * Author: Payable
 * Author URI: https://payable.lk
 * Text Domain: woo-payablev2
 *
 * @package Payable\WooCommercePayable
 */
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

*/

// Exit if accessed directly.
if (!defined('ABSPATH')) {
    exit;
}

class wc_WooCommercePayable
{

    /**
     * Plugin bootstrapping.
     */
    public static function init()
    {

        // Payments gateway class.
        add_action('plugins_loaded', array(__CLASS__, 'includes'), 0);

        // Make the Payments gateway available to WC.
        add_filter('woocommerce_payment_gateways', array(__CLASS__, 'add_gateway'));
    }

    /**
     * Add the  Payment gateway to the list of available gateways.
     *
     * @param array
     */
    public static function add_gateway($gateways)
    {
        $gateways[] = 'Wc_WooCommercePayablepayment';
        return $gateways;
    }

    /**
     * Plugin includes.
     */
    public static function includes()
    {

        // Make the WC_Gateway class available.
        if (class_exists('WC_Payment_Gateway')) {
            require_once 'includes/class-wc-gateway-payable.php';
        }
    }

    /**
     * Plugin url.
     *
     * @return string
     */
    public static function plugin_url()
    {
        return untrailingslashit(plugins_url('/', __FILE__));
    }
}

wc_WooCommercePayable::init();
require_once plugin_dir_path( __FILE__ ) . 'includes/payable-functions.php';



// function add_payable_page() {
//     // Create post object
//     $payable_post = array(
//       'post_title'    => wp_strip_all_tags( 'Payable Payment' ),
//       'post_content'  => '',
//       'post_status'   => 'publish',
//       'post_author'   => 1,
//       'post_type'     => 'page',
//       // Assign page template
//       'page_template'  => 'payable-full-width.php'
//     );

//     // Insert the post into the database
//     wp_insert_post( $payable_post );
// }

register_activation_hook(__FILE__, 'add_payable_page');
